Option Explicit On 

Imports System.Text

Module basUtility

    Declare Function GetPrivateProfileString Lib "KERNEL32.DLL" Alias "GetPrivateProfileStringA" ( _
     ByVal lpAppName As String, _
     ByVal lpKeyName As String, ByVal lpDefault As String, _
     ByVal lpReturnedString As StringBuilder, ByVal nSize As Integer, _
     ByVal lpFileName As String) As Integer

    Declare Function WritePrivateProfileString Lib "KERNEL32.DLL" Alias "WritePrivateProfileStringA" ( _
     ByVal lpAppName As String, _
     ByVal lpKeyName As String, _
     ByVal lpString As String, _
     ByVal lpFileName As String) As Integer

    Public ImportRA As clsImportRA
    Public ImportSE As clsImportSE
    Public ImportUM As clsImportUM

    Public objCDCv As clsCodeConv

    Public strConnectString As String

    ' @(f)
    '
    ' @\@@@: woCg܂ŋ󔒂uEɁvt
    '
    ' Ԃl@@: woCg 
    '
    ' @@: strpad - Ώە(bytewɖ)
    '          : totalBytes - w肷oCg
    ' 
    ' l     : ʏPadRight͑Sp(2byte)1Ɛ̂ŁA
    '            oCgŎw肷邱ƂőSpp킹邱ƂeՂƂȂ
    ' 
    Public Function bPadR(ByVal strPad As String, ByVal totalBytes As Integer) As String

        Dim strReturn As String
        Dim intTmp As Integer
        Dim bBuff As Byte()
        Dim bSize As Long

        If strPad Is Nothing Then
            strPad = ""
        End If
        bSize = Str2Byte(strPad).Length
        bBuff = New Byte(bSize) {}

        bBuff = Str2Byte(strPad)
        If bBuff.Length < totalBytes Then
            If bBuff.Length.Equals(strPad.Length) Then
                strReturn = strPad.PadRight(totalBytes)
            Else
                intTmp = totalBytes - (bBuff.Length - strPad.Length)
                strReturn = strPad.PadRight(intTmp)
            End If
        Else
            strReturn = strPad
        End If

        bPadR = strReturn
    End Function

    ' @(f)
    '
    ' @\@@@: woCg܂ŋ󔒂uɁvt
    '
    ' Ԃl@@: woCg 
    '
    ' @@: strpad - Ώە(bytewɖ)
    '          : totalBytes - w肷oCg
    ' 
    ' l     : ʏPadLeft͑Sp(2byte)1Ɛ̂ŁA
    '            oCgŎw肷邱ƂőSpp킹邱ƂeՂƂȂ
    ' 
    Public Function bPadL(ByVal strPad As String, ByVal totalBytes As Integer) As String

        Dim strReturn As String
        Dim intTmp As Integer
        Dim bBuff As Byte()
        Dim bSize As Long

        If strPad Is Nothing Then
            strPad = ""
        End If
        bSize = Str2Byte(strPad).Length
        bBuff = New Byte(bSize) {}

        bBuff = Str2Byte(strPad)
        If bBuff.Length < totalBytes Then
            If bBuff.Length.Equals(strPad.Length) Then
                strReturn = strPad.PadLeft(totalBytes)
            Else
                intTmp = totalBytes - (bBuff.Length - strPad.Length)
                strReturn = strPad.PadLeft(intTmp)
            End If
        Else
            strReturn = strPad
        End If

        bPadL = strReturn
    End Function


    ' @(f)
    '
    ' @\@@@: 񂩂󔒕𔲂
    '
    ' Ԃl@@: 󔒂𔲂Ώۂ̕
    '
    ' @@: strTrim - (bytewɖ)
    '
    Public Function TrimSP(ByVal strTrim As String) As String

        Dim strReturn As String
        Dim i As Short ' [vJE^
        Dim strTmp As String
        strReturn = ""

        For i = 0 To strTrim.Length - 1
            ' Ώە̐擪1ׂ
            strTmp = strTrim.Substring(i, 1)
            ' pASp̋󔒂AɊi[
            If strTmp.Equals(" ") Or strTmp.Equals("@") Then
            Else
                strReturn = strReturn & strTmp
            End If
        Next i

        TrimSP = strReturn
    End Function


    ' @(f)
    '
    ' @\@@@: O[hR[h   Ǖɂ
    '
    ' Ԃl@@:  
    '
    ' @@: strCD - O[hR[h(1byte)
    '
    Public Function GRAD2(ByVal strCD As String) As String
        GRAD2 = String.Empty
        Select Case strCD
            Case "A"
                GRAD2 = "(fT)"
            Case "B"
                GRAD2 = "(fU)"
            Case "C"
                GRAD2 = "(fV)"
            Case "D"
                GRAD2 = ""
            Case "E"
                GRAD2 = ""
            Case "F"
                GRAD2 = "(JfT)"
            Case "G"
                GRAD2 = "(JfU)"
            Case "H"
                GRAD2 = "(JfV)"
            Case " "
                GRAD2 = ""
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: O[hR[h   Ǖɂ
    '
    ' Ԃl@@:  
    '
    ' @@: strCD - O[hR[h(1byte)
    '
    Public Function GRAD3(ByVal strCD As String) As String
        GRAD3 = String.Empty
        Select Case strCD
            Case "A"
                GRAD3 = "(fT)"
            Case "B"
                GRAD3 = "(fU)"
            Case "C"
                GRAD3 = "(fV)"
            Case "D"
                GRAD3 = ""
            Case "E"
                GRAD3 = ""
            Case "F"
                GRAD3 = "(JGT)"
            Case "G"
                GRAD3 = "(JGU)"
            Case "H"
                GRAD3 = "(JGV)"
            Case " "
                GRAD3 = ""
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: ʃR[h   Ǖɂ
    '
    ' Ԃl@@:  
    '
    ' @@: strCD - ʃR[h(2byte)
    '
    Public Function KSSB6(ByVal strCD As String) As String
        KSSB6 = String.Empty
        Select Case strCD
            Case "0"
                KSSB6 = ""
            Case "11"
                KSSB6 = "Q" '"Tubhn2"
            Case "12"
                KSSB6 = "R" '"Tubhn3"
            Case "13"
                KSSB6 = "RΏ" '"Tubhn3Έȏ"
            Case "14"
                KSSB6 = "SΏ" '"Tubhn4Έȏ"
            Case "18"
                KSSB6 = "RΏ" '"TubhnQ3Έȏ"
            Case "19"
                KSSB6 = "SΏ" '"TubhnQ4Έȏ"
            Case "21"
                KSSB6 = "Q" '"Aun2"
            Case "22"
                KSSB6 = "R" '"Aun3"
            Case "23"
                KSSB6 = "RΏ" '"Aun3Έȏ"
            Case "24"
                KSSB6 = "SΏ" '"Aun4Έȏ"
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: ʃR[h   Ǖɂ
    '
    ' Ԃl@@:  
    '
    ' @@: strCD - ʃR[h(2byte)
    '
    Public Function KSSB7(ByVal strCD As String) As String
        KSSB7 = String.Empty
        Select Case strCD
            Case "0"
                KSSB7 = ""
            Case "11"
                KSSB7 = "Q" '"Tubhn2"
            Case "12"
                KSSB7 = "R" '"Tubhn3"
            Case "13"
                KSSB7 = "RΏ" '"Tubhn3Έȏ"
            Case "14"
                KSSB7 = "SΏ" '"Tubhn4Έȏ"
            Case "18"
                KSSB7 = "QRΏ" '"TubhnQ3Έȏ"
            Case "19"
                KSSB7 = "QSΏ" '"TubhnQ4Έȏ"
            Case "21"
                KSSB7 = "Q" '"Aun2"
            Case "22"
                KSSB7 = "R" '"Aun3"
            Case "23"
                KSSB7 = "RΏ" '"Aun3Έȏ"
            Case "24"
                KSSB7 = "SΏ" '"Aun4Έȏ"
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: R[h   Ǖɂ
    '
    ' Ԃl@@:  
    '
    ' @@: strCD - R[h(3byte)
    '
    Public Function KSJK4(ByVal strCD As String) As String
        KSJK4 = String.Empty
        Select Case Val(strCD)
            Case 0
                KSJK4 = ""
            Case 1 To 99
                KSJK4 = 100 * Val(strCD) & ""
            Case 100
                KSJK4 = "P"
            Case "701"
                KSJK4 = "Vn"
            Case "702"
                KSJK4 = "o"
            Case "703"
                KSJK4 = ""
            Case "999"
                KSJK4 = ""
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: ʃR[h   Ǖɂ
    '
    ' Ԃl@@:  
    '
    ' @@: strCD - ʃR[h(1byte)
    '
    Public Function SEIB4(ByVal strCD As String) As String
        SEIB4 = String.Empty
        Select Case strCD
            Case "0"
                SEIB4 = ""
            Case "1"
                SEIB4 = ""
            Case "2"
                SEIB4 = ""
            Case "3"
                SEIB4 = "x"
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: gwiF̎w
    '
    ' Ԃl@@: gwiF RGBl(&H16i\L)
    '
    ' @@: strCD - gԕ(1byte)
    '
    Public Function CELBK1(ByVal strCD As String) As String
        CELBK1 = String.Empty
        Select Case strCD
            Case "0"
                CELBK1 = "&HFFFFFF"
            Case "1"
                CELBK1 = "&HFFFFFF"
            Case "2"
                CELBK1 = "&H010000"
            Case "3"
                CELBK1 = "&HFF0000"
            Case "4"
                CELBK1 = "&H0000FF"
            Case "5"
                CELBK1 = "&HFFFF00"
            Case "6"
                CELBK1 = "&H00FF00"
            Case "7"
                CELBK1 = "&HFF8000"
            Case "8"
                CELBK1 = "&HFF8080"
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: wiF̎w
    '
    ' Ԃl@@: wiF RGBl(&H16i\L)
    '
    ' @@: strCD - (1byte)
    '
    Public Function CELBK2(ByVal strCD As String) As String
        CELBK2 = String.Empty
        Select Case strCD
            Case "01"
                CELBK2 = "&HFFCCCC"
            Case "02"
                CELBK2 = "&HFFCC80"
            Case "03"
                CELBK2 = "&HCCFFFF"
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: gF̎w
    '
    ' Ԃl@@: gF 
    '
    ' @@: strCD - gԕ(1byte)
    '
    Public Function CELFK(ByVal strCD As String) As String
        CELFK = String.Empty
        Select Case strCD
            Case "0"
                CELFK = ""
            Case "1"
                CELFK = ""
            Case "2"
                CELFK = "White"
            Case "3"
                CELFK = "White"
            Case "4"
                CELFK = "White"
            Case "5"
                CELFK = ""
            Case "6"
                CELFK = ""
            Case "7"
                CELFK = ""
            Case "8"
                CELFK = ""
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: gbNR[h   Ǖɂ
    '
    ' Ԃl@@:  
    '
    ' @@: strCD - gbNR[h(2byte)
    '
    Public Function TRCK4(ByVal strCD As String) As String
        TRCK4 = String.Empty
        Select Case strCD
            Case "00"
                TRCK4 = ""
            Case "10" To "22"
                TRCK4 = ""
            Case "23" To 26, "29"
                TRCK4 = "_"
            Case "27", "28"
                TRCK4 = ""
            Case "51" To "59"
                TRCK4 = ""
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: gbNR[h   Ǖɂ
    '
    ' Ԃl@@:  
    '
    ' @@: strCD - gbNR[h(2byte)
    '
    Public Function TRCK5(ByVal strCD As String) As String
        TRCK5 = String.Empty
        Select Case strCD
            Case "00"
                TRCK5 = ""
            Case "10"
                TRCK5 = "Œ"
            Case "11" To "16"
                TRCK5 = "ō"
            Case "17" To "22"
                TRCK5 = "ŉE"
            Case "23", "25"
                TRCK5 = "_"
            Case "24", "26"
                TRCK5 = "_E"
            Case "27"
                TRCK5 = ""
            Case "28"
                TRCK5 = "E"
            Case "29"
                TRCK5 = "_"
            Case "51" To "59"
                TRCK5 = "Q"
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: nԃR[h   Ǖɂ
    '
    ' Ԃl@@:  
    '
    ' @@: strCD - nԃR[h(1byte)
    '
    Public Function BBJT4(ByVal strCD As String) As String
        BBJT4 = String.Empty
        Select Case strCD
            Case "0"
                BBJT4 = ""
            Case "1"
                BBJT4 = ""
            Case "2"
                BBJT4 = "c"
            Case "3"
                BBJT4 = "d"
            Case "4"
                BBJT4 = "s"
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: f[^敪 Ǖɂ
    '
    ' Ԃl@@: 敪 
    '
    ' @@: strCD - f[^敪(1byte)
    '
    Public Function DTKB1(ByVal strCD As String) As String
        DTKB1 = String.Empty
        Select Case strCD
            Case "1"
                DTKB1 = "on\(ؗj)"
            Case "2"
                DTKB1 = "on\(Eyj)"
            Case "3"
                DTKB1 = "񐬐(3܂Ŋm)"
            Case "4"
                DTKB1 = "񐬐(5܂Ŋm)"
            Case "5"
                DTKB1 = "񐬐(Snm)"
            Case "6"
                DTKB1 = "񐬐(Sn+Űʉߏ)"
            Case "7"
                DTKB1 = "(j)"
            Case "A"
                DTKB1 = "nn"
            Case "B"
                DTKB1 = "COۃ[X"
            Case "9"
                DTKB1 = "[X~"
            Case "0"
                DTKB1 = "YR[h폜"
        End Select
    End Function

    ' @(f)
    '
    ' @\@@@: vt@C̃f[^擾
    '
    ' Ԃl@@: vt@Cf[^
    '
    ' @@: strAppName - ZNV
    '            strKeyName - L[
    '            strFileName - vt@C
    '
    Public Function GetProfileDataStr(ByVal strAppName As String, ByVal strKeyName As String, ByVal strFileName As String) As String

        Dim iReturnCode As String
        Dim sb As StringBuilder = New StringBuilder(1024)

        ' ǂݏo
        iReturnCode = GetPrivateProfileString(strAppName, strKeyName, "default", sb, sb.Capacity, strFileName)

        GetProfileDataStr = sb.ToString

    End Function

    ' @(f)
    '
    ' @\@@@: vt@Cւ̃f[^ݒ
    '
    ' @@: strAppName - ZNV
    '            strKeyName - L[
    '            strValue - ݒl
    '            strFileName - vt@C
    '
    Public Sub WriteProfileDataStr(ByVal strAppName As String, ByVal strKeyName As String, ByVal strValue As String, ByVal strFileName As String)

        WritePrivateProfileString(strAppName, strKeyName, strValue, strFileName)

    End Sub


    ' @(f)
    '
    ' @\@@@: f[^x[Xڑs
    '
    ' Ԃl@@: (True-I, False-ُI)
    '
    Public Function ConnectDB() As Boolean
        On Error GoTo ErrorHandler

        Dim bReturnCode As Boolean
        bReturnCode = False

        'ڑ

        ' f[^x[XƂ̐ڑsB
        gCon = New ADODB.Connection()
        Dim strPath As String

        ' f[^x[X̃I[v
        gCon.Open(strConnectString)

        bReturnCode = True

ExitHandler:
        ConnectDB = bReturnCode
        Exit Function

ErrorHandler:
        System.Diagnostics.Debug.WriteLine(Err.Description)
        bReturnCode = False

        MsgBox(Err.Description)
        Resume ExitHandler

    End Function

End Module
